package com.iformall.controller.basic;

import com.github.pagehelper.PageInfo;
import com.iformall.annotation.SystemControllerLog;
import com.iformall.common.Result;
import com.iformall.common.ResultData;
import com.iformall.controller.base.BaseController;
import com.iformall.domain.po.WxPayAccountBill;
import com.iformall.service.WxPayAccountBillService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

@RestController
@RequestMapping("wxPayAccountBill")
@Api(description = "B端小程序账单支付商户号设置接口")
public class WxPayAccountBillController extends BaseController {
    private final Logger logger = LoggerFactory.getLogger(this.getClass());

    @Autowired
    private WxPayAccountBillService wxPayAccountBillService;

    @ApiOperation("分页列表接口")
    @GetMapping("list")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "页数", dataType = "int", paramType = "query", required = true),
            @ApiImplicitParam(name = "pageSize", value = "每页条数", dataType = "int", paramType = "query", required = true)})
    @SystemControllerLog(description = "支付账号-列表")
    public ResultData list(@ModelAttribute WxPayAccountBill wxPayAccountBill, Integer pageNum, Integer pageSize) {
        logger.debug("[" + getIpAddr() + "] WxPayAccountBillController::list");
        if (null == wxPayAccountBill) wxPayAccountBill = new WxPayAccountBill();
        final PageInfo<WxPayAccountBill> page = wxPayAccountBillService.listAsPage(wxPayAccountBill, pageNum, pageSize);
        return new ResultData(page);
    }

    @ApiOperation("新增接口")
    @PostMapping("add")
    @SystemControllerLog(description = "支付账号-新增")
    public ResultData add(@RequestBody WxPayAccountBill wxPayAccountBill) {
        logger.debug("[" + getIpAddr() + "] WxPayAccountBillController::add");
        wxPayAccountBillService.saveOrUpdate(wxPayAccountBill);
        return new ResultData();
    }

    @ApiOperation("根据id更新接口")
    @PostMapping("update")
    @SystemControllerLog(description = "支付账号-更新")
    public ResultData update(@RequestBody WxPayAccountBill wxPayAccountBill) {
        logger.debug("[" + getIpAddr() + "] WxPayAccountBillController::update");
        wxPayAccountBillService.saveOrUpdate(wxPayAccountBill);
        return new ResultData();
    }

    @ApiOperation("根据id删除接口")
    @GetMapping("/del")
    @ApiImplicitParam(name = "id", value = "id", dataType = "Long", paramType = "query", required = true)
    @SystemControllerLog(description = "支付账号-删除")
    public ResultData delete(Long id) {
        logger.debug("[" + getIpAddr() + "] WxPayAccountController::delete");
        wxPayAccountBillService.deleteById(id);
        return new ResultData(Result.SUCCESS, "删除成功", null);
    }

    @ApiOperation("根据id查询接口")
    @GetMapping("/findById")
    @ApiImplicitParam(name = "id", value = "id", dataType = "Long", paramType = "query", required = true)
    @SystemControllerLog(description = "支付账号-查询")
    public ResultData findById(Long id) {
        logger.debug("[" + getIpAddr() + "] WxPayAccountBillController::findById");
        return new ResultData(Result.SUCCESS, "查询成功", wxPayAccountBillService.getById(id));
    }


}
